
#Region "Header Information"
' -----------------------------------------------------------------------------
' Project: [ARDISOptiSave]
' Form/Class  : [IniFile]
' 
' -----------------------------------------------------------------------------
' <summary>
' 
'   
' 
' </summary>
' <remarks>
'
' </remarks>
' Revision History
' Date       Name            Description
' ========   ============    ===========
' 02/14/08   Patrick Roy     Created form and routines 
'
'
' </history>
'
'
' -----------------------------------------------------------------------------
#End Region

Imports System.IO
Imports System.Math
Imports System.Security
Imports System.Security.Cryptography
Imports System.Text
Imports System.Collections


Public Class IniFile
     Private CLASS_NAME As String = MyBase.GetType().Name

     ' VB.NET declaration
     'Private Declare Ansi Function GetPrivateProfileString Lib "KERNEL32.DLL"()Alias "GetPrivateProfileStringA" (ByVal lpAppName As String,ByVal lpKeyName As String,ByVal lpDefault As String,ByVal lpReturnedString As StringBuilder,ByVal nSize As Integer,ByVal lpFileName As String) As Integer


#Region "Public/Private variables"
     Private _strFileName As String
     Private _strIniArgumentsBegins As String
     'Private _strIniArgumentsBegins As String = "[Arguments]"
     Private _strPrefix As String
     Private _dt As DataTable
     Private _ds As DataSet
     Private _dv As DataView
     Private _dr As DataRow
     Private TmpStringInhaltKomplett As New StringBuilder
     Private StringIniFile As String
#End Region 'Public/Private variables

#Region "Properties"
     Public Property Filename() As String
          Get
               Return _strFileName
          End Get
          Set(ByVal Value As String)
               _strFileName = Value
          End Set
     End Property
     Public Property Prefix() As String
          Get
               Return _strPrefix
          End Get
          Set(ByVal Value As String)
               _strPrefix = Value
          End Set
     End Property

#End Region 'Properties

#Region "Class Methods"
     Public Sub New()
          _ds = New DataSet
          _dt = New DataTable
          _dv = New DataView
          '...............................
          _dt.Columns.Add("Section")
          _dt.Columns.Add("Key")
          _dt.Columns.Add("Value")
          '...............................
          _ds.Tables.Add(_dt)
          _dv.Table = _ds.Tables(0)
     End Sub
#End Region

#Region "Functions and subroutines"
     Public Function OpenIniFile() As Boolean
          Try
               Dim tmpStringLine As String
               Dim tmpStringArguments() As String
               Dim tmpBool As Boolean = False
               If Not File.Exists(Filename) Then
                    Return False
               End If
               Dim ssr As StreamReader = New StreamReader(Filename)
               _ds = New DataSet
               _dt = New DataTable
               _dv = New DataView
               _dt.Columns.Add("Section")
               _dt.Columns.Add("Key")
               _dt.Columns.Add("Value")

               _ds.Tables.Add(_dt)
               _dv.Table = _ds.Tables(0)
               Do
                    tmpStringLine = ssr.ReadLine()
                    If tmpStringLine Is Nothing Then Exit Do
                    If tmpBool Then
                         Try
                              tmpStringArguments = tmpStringLine.Split("=")
                              _dr = _ds.Tables(0).NewRow
                              _dr("Key") = tmpStringArguments(0)
                              _dr("Value") = tmpStringArguments(1)
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    End If
                    If tmpStringLine.StartsWith(_strIniArgumentsBegins) Then
                         tmpBool = True
                         _strPrefix = TmpStringInhaltKomplett.ToString
                    End If
                    TmpStringInhaltKomplett.Append(tmpStringLine & Environment.NewLine)
               Loop Until tmpStringLine Is Nothing
               ssr.Close()
               StringIniFile = TmpStringInhaltKomplett.ToString
               Return True
               _ds.AcceptChanges()
          Catch ex As Exception
               Return False
          End Try
     End Function
     Public Function GetValue(ByVal Key As String) As String
          _dv.RowFilter = "Key = '" & Key & "'"
          If _dv.Count > 0 Then
               Return _dv.Item(0).Item("Value")
          Else
               Return "NOTHING"
          End If
     End Function
     Public Function SetValue(ByVal Key As String, ByVal Value As String) As Boolean
          _dv.RowFilter = "Key = '" & Key & "'"
          If _dv.Count > 0 Then
               _dv.Item(0).Item("Value") = Value
               'Console.WriteLine("nderung am Key '{0}'", Key)
          Else
               _dr = _ds.Tables(0).NewRow
               _dr("Key") = Key
               _dr("Value") = Value
               _ds.Tables(0).Rows.Add(_dr)
               'Console.WriteLine("Neuer Eintrag: Key ='{0}' & Value = {1}", Key, Value)
          End If
     End Function
     Public Function SaveIni() As Boolean
          If Not IsNothing(_ds.GetChanges) Then
               SetValue("_LastSaveOfIniFile", Date.Now.ToLongDateString)
               Try
                    _dv.RowFilter = ""
                    _dv.Sort = "KEY ASC"
                    Dim StringIni As New StringBuilder
                    StringIni.Append(_strPrefix & Environment.NewLine)
                    StringIni.Append(_strIniArgumentsBegins & Environment.NewLine)
                    Dim i As Integer
                    For i = 0 To _dv.Count - 1
                         StringIni.Append(_dv.Item(i).Item("Key") & "=" & _dv.Item(i).Item("Value") & Environment.NewLine)
                    Next
                    If File.Exists(_strFileName) Then File.Delete(_strFileName)
                    Dim ssw As New StreamWriter(_strFileName)
                    ssw.WriteLine(StringIni.ToString)
                    ssw.Close()
                    _ds.AcceptChanges()
                    Return True
               Catch ex As Exception
                    Return False
               End Try
          Else
               Return True
          End If
     End Function

#End Region 'Functions and subroutines



End Class

Public Class R41Files
     Private CLASS_NAME As String = MyBase.GetType().Name

#Region "Enums"
     Public Enum Sections
          _OPTPAR = 10
          _ISTK = 20
          _ISTD = 30
          _MAT = 40
          _STDB = 50
          _LAYSTS = 60
          _STKSTS = 70
          _LOCSTS = 80
          _SUBSTS = 90
          _MCHB = 100
          _LAYOUTS = 110
          _STROKEN = 111
          _LAYSTK = 112
          _STKPROD = 120
          _MATRES = 130
          _STKBRES = 140
          _MATSTKBRES = 150
          _ERROR = 160
          _ALGRES = 170
          _STKB = 180
     End Enum
     Public Enum Keys
          _REF = 10 'BOARD COST
          _BEM = 20 'BOARD NUMBER - ALSO STANDARD BOARD
          _MACH = 30 'MACHINE
          _STDNR = 40 'STANDARD NUMBER - OPTI BOARD IF #1
          _NETTOPP = 50 '..USED TO CALCULATE PERCENTAGE INFO
          _BRUTOPP = 60 '..USED TO CALCULATE PERCENTAGE INFO
          _MAT = 70 'MATERIAL
          _AANT = 80 'PART QTY
          _MELDING = 90 'ERROR MSG
          _NOLIMIT = 100 'INDICATES BOARD IS NO LONGER USED (N/A)
     End Enum
#End Region 'Enums

#Region "Public/Private variables"
     Private _strR41FileName As String
     Private _strOPTPARArguments As String = "[OPTPAR]"
     Private _strISTKArguments As String = "[ISTK-1]"
     Private _strMATArguments As String = "[MAT-1]"
     Private _strSTKBArguments As String = "[STKB-1]"
     Private _strLAYSTSArguments As String = "[LAYSTS]"
     Private _strSTKSTSArguments As String = "[STKSTS]"
     Private _strLOCSTSArguments As String = "[LOCSTS]"
     Private _strSUBSTSArguments As String = "[SUBSTS]"
     Private _strMCHBArguments As String = "[MCHB-1]"
     Private _strSTKPRODArguments As String = "[STKPROD-1]"
     Private _strSTKBRESArguments As String = "[STKPRES-1]"
     Private _strMATSTKBRESArguments As String = "[MATSTKBRES-1]"
     Private _strISTDArguments As String 'Exp: [ISTD-##]
     Private _strSTDBArguments As String 'Exp: [STDB-##]
     Private _strLAYOUTSArguments As String 'Exp: [LAYOUTS-##]
     Private _strSTROKENArguments As String 'Exp: [STROKEN-##]
     Private _strLAYSTKArguments As String 'Exp: [LAYSTK-##]
     Private _strPrefix As String
     Private _dt As DataTable
     Private _ds As DataSet
     Private _dv As DataView
     Private _dr As DataRow
     Private TmpStringInhaltKomplett As New StringBuilder
     Private StringR41File As String
#End Region 'Public/Private variables
#Region "Properties"
     Public Property R41Filename() As String
          Get
               Return _strR41FileName
          End Get
          Set(ByVal Value As String)
               _strR41FileName = Value
          End Set
     End Property
     Public Property Prefix() As String
          Get
               Return _strPrefix
          End Get
          Set(ByVal Value As String)
               _strPrefix = Value
          End Set
     End Property
     Public Property GetDataSet() As DataSet
          Get
               Return _ds
          End Get
          Set(ByVal value As DataSet)
               _ds = value
          End Set
     End Property

#End Region 'Properties
#Region "Class Methods"
     Public Sub New()
          _ds = New DataSet
          _dt = New DataTable
          _dv = New DataView
          '...............................
          _dt.Columns.Add("Section")
          _dt.Columns.Add("Key")
          _dt.Columns.Add("Value")
          '...............................
          _ds.Tables.Add(_dt)
          _dv.Table = _ds.Tables(0)
     End Sub
#End Region
#Region "Functions and subroutines"
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function OpenR41File() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "OpenR41File"
          '--------------------------------------
          Try
               Dim tmpStringLine As String
               Dim tmpStrLn2 As String
               Dim tmpStringArguments() As String
               Dim tmpBool As Boolean = False
               Dim tmpStr1 As String = "["
               Dim tmpStr2 As String = "="
               If Not File.Exists(R41Filename) Then
                    Return False
               End If
               Dim ssr As StreamReader = New StreamReader(R41Filename)
               _ds = New DataSet
               _dt = New DataTable
               _dv = New DataView
               _dt.Columns.Add("Section")
               _dt.Columns.Add("Key")
               _dt.Columns.Add("Value")

               _ds.Tables.Add(_dt)
               _dv.Table = _ds.Tables(0)
               tmpStrLn2 = ""
               Do
                    tmpStringLine = ssr.ReadLine()
                    If tmpStringLine Is Nothing Then GoTo Continue1
                    '.... determine if comment or section or key .....
                    If InStr(tmpStringLine, tmpStr1) Then 'section...
                         Try
                              tmpStrLn2 = ""
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStringLine
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                              tmpStrLn2 = tmpStringLine
                         Catch ex As Exception

                         End Try
                    ElseIf InStr(tmpStringLine, tmpStr2) Then 'key...
                         Try
                              tmpStringArguments = tmpStringLine.Split("=")
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStrLn2
                              _dr("Key") = tmpStringArguments(0)
                              _dr("Value") = tmpStringArguments(1)
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine <> "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = tmpStringLine
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine = "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    End If
                    '......................................
                    TmpStringInhaltKomplett.Append(tmpStringLine & Environment.NewLine)
Continue1:
               Loop Until ssr.EndOfStream 'tmpStringLine Is Nothing
               ssr.Close()
               StringR41File = TmpStringInhaltKomplett.ToString
               Return True
               _ds.AcceptChanges()
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetSectionValue(ByVal oKey As Keys, _
                              ByVal kValue As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetSectionValue"
          '--------------------------------------
          '------------------------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '.... get key value for filter ...........
               keyValue = DetermineKeyText(oKey)
               strFilter = "Key = '" & keyValue & "' and Value = '" & kValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Section")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "-Nothing"
          Finally
               FUNCTION_NAME = Nothing

          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetValue(ByVal sSection As String, _
                              ByVal oKey As Keys) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetValue"
          '--------------------------------------
          '----------------------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Value")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "-Nothing"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetBoardCount(ByVal oSection As Sections) As Integer
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetBoardCount"
          '--------------------------------------
          Dim bolAnswer As Boolean
          Try

               Dim sectValue As String
               Dim strFilter As String
               Dim intcntr As Integer
               Dim intSectionCnt As Integer

               sectValue = DetermineSectionText(oSection)
               strFilter = "[" & sectValue
               For intcntr = 0 To _dv.Count - 1
                    If _dv.Item(intcntr).Item("Section") <> "" And _dv.Item(intcntr).Item("Key") = "" Then
                         If InStr(_dv.Item(intcntr).Item("Section"), strFilter) = 1 Then
                              intSectionCnt += 1
                         End If
                    End If
               Next
               Return intSectionCnt / 2

          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               bolAnswer = False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function UpdateR41BoardCostFile(ByVal sDirectory As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "UpdateR41BoardCostFile"
          '--------------------------------------
          Try
               '... not currently used....


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CheckCurrentR41FileDate() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CheckCurrentR41FileDate"
          '--------------------------------------R41Filename
          Dim strMsg As String = Nothing
          Dim strMsgTitle As String = Nothing
          Dim returnValue As DialogResult = Nothing
          Dim fileDate As Date = Nothing
          Dim todaysDate As Date = Nothing
          '.....................................
          Try
               '.......................................
               If File.Exists(_strR41FileName) Then
                    '.......................................
                    fileDate = FormatDateTime(File.GetLastWriteTime(_strR41FileName), DateFormat.ShortDate)
                    todaysDate = FormatDateTime(Now, DateFormat.ShortDate)
                    If fileDate <> todaysDate Then
                         Return True
                    Else
                         strMsg = "The file " & _strR41FileName & vbCrLf
                         strMsg = strMsg & "was changed today ........" & vbCrLf
                         strMsg = strMsg & "Current File: " & fileDate & vbCrLf
                         strMsg = strMsg & "New File    : " & Now & vbCrLf
                         strMsg = strMsg & "-----------------------------------------" & vbCrLf
                         strMsg = strMsg & "Do you want to continue?"
                         strMsgTitle = "FILE DATE DIFFERENCE"
                         returnValue = MessageBox.Show(strMsg, strMsgTitle, MessageBoxButtons.YesNo, MessageBoxIcon.Warning)
                         If returnValue = DialogResult.Yes Then
                              Return True
                         Else
                              Return False
                         End If
                    End If
                    '.......................
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
               strMsg = Nothing
               strMsgTitle = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetStandardBoard() As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetStandardBoard"
          '--------------------------------------
          Try


               Return "??"
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Nothing"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetOptiBoard() As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetOptiBoard"
          '--------------------------------------
          Try


               Return "??"
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Nothing"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetYeildPercent() As Double
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetYeildPercent"
          '--------------------------------------
          Try


               Return 0
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return -1
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetWastePercent() As Double
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetWastePercent"
          '--------------------------------------
          Try


               Return 0
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return -1
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CheckBoardAvailabity() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CheckBoardAvailabity"
          '--------------------------------------
          Try


               Return True
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CreateR41File(ByVal sPartNumber As String, ByVal sMachine As String, _
                                    ByVal sBoard As String, ByVal bSortByCost As Boolean, _
                                    Optional ByVal bBestBoard As Boolean = False) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "UpdateSTDBoardFiles"
          '--------------------------------------
          Try
               Dim strTemp As String
               Dim fw As StreamWriter
               Dim sbR41 As New StringBuilder
               '..............................
               With sbR41
                    '........ CHANGE CODE .......
                    .Append("[Stock]" & vbCrLf)
                    .Append("[Stock]" & vbCrLf)
                    '........................
                    .Append(vbCrLf)
                    '..............................
                    .Append("[LOCSTS]" & vbCrLf)
                    .Append("LDEC = 1" & vbCrLf)
                    .Append("WDEC = 1" & vbCrLf)
                    .Append("SQRDEC = 2" & vbCrLf)
                    .Append("THICKDEC = 1" & vbCrLf)
                    .Append("HEIGHTDEC = 1" & vbCrLf)
                    .Append("SQRFACTOR = 1000000" & vbCrLf)
                    .Append("WEIGHTDEC = 1" & vbCrLf)
                    .Append("WSQRDEC = 2" & vbCrLf)
                    .Append("CURRENCYDEC = 2" & vbCrLf)
                    .Append("TIMEDEC = 1" & vbCrLf)
                    .Append("DATEIN = 1" & vbCrLf)
                    .Append("DATEOUT = 6" & vbCrLf)
                    .Append("[LOCSTS]" & vbCrLf)
                    '...........................
                    .Append(vbCrLf)
                    '................................
                    .Append("[SUBSTS]" & vbCrLf)
                    .Append("FLAG = 1" & vbCrLf)
                    .Append("[SUBSTS]" & vbCrLf)
                    '.............................
                    .Append(vbCrLf)
                    '...............................
                    .Append("[MCHB-1]" & vbCrLf)
                    '........... MODIFY CODE .............
                    strTemp = "NAAM=" & g_oSetupData.PART_LOCATION & sMachine & ".mch"
                    .Append("NAAM=" & g_oSetupData.PART_LOCATION & sMachine & ".mch" & vbCrLf)
                    .Append("[MCHB-1]" & vbCrLf)
                    '....................................
                    .Append(vbCrLf)
                    '.......................................
                    .Append("[ALGRES]" & vbCrLf)
                    .Append("[ALGRES]" & vbCrLf)
                    '......................................
                    .Append(vbCrLf)
                    '.......................................
                    .Append("[STKSTS]" & vbCrLf)
                    .Append("STKJOIN = 1" & vbCrLf)
                    .Append("STKJOINPRI = 1" & vbCrLf)
                    .Append("STKJOINEDGE = 1" & vbCrLf)
                    .Append("FLAG = 1" & vbCrLf)
                    .Append("[STKSTS]" & vbCrLf)
                    '................................
                    .Append(vbCrLf)
                    '.....................................
                    .Append("[OPTPAR]" & vbCrLf)
                    .Append("MODE=1" & vbCrLf)
                    .Append("ALGOR=1" & vbCrLf)
                    '..............................................
                    'flag sorts ardis output by cost if checked to true
                    If bSortByCost = True Then
                         .Append("KOSTEN=1" & vbCrLf) 'TODO this needs to be configurable remove if checked no
                    End If
                    '............................................
                    If bBestBoard = True Then
                         .Append("BEM=AANTSTD=1" & vbCrLf)
                    End If
                    '...................................
                    .Append("MINNIV=99" & vbCrLf)
                    .Append("MAXNIV=99" & vbCrLf)
                    .Append("VERSION=Cutting Optimizer 4.97" & vbCrLf)
                    .Append("USERNAME=ARDIS US         4842 / 2" & vbCrLf)
                    .Append("[OPTPAR]" & vbCrLf)
                    '..........................
                    .Append(vbCrLf)
                    '...............................
                    .Append("[LAYSTS]" & vbCrLf)
                    .Append("ShowEdge = 1" & vbCrLf)
                    .Append("FLAG = 1" & vbCrLf)
                    .Append("[LAYSTS]" & vbCrLf)
                    '..............................
                    .Append(vbCrLf)
                    '..............................
                    .Append("[STKB-1]" & vbCrLf)
                    '........... MODIFY CODE .............
                    .Append("NAAM=" & g_oSetupData.PART_LOCATION & Trim(sPartNumber) & ".stk" & vbCrLf)
                    '.Append("NAAM=" & PART_LOCATION_TEST & Trim(sPartNumber) & ".stk" & vbCrLf)
                    .Append("[STKB-1]" & vbCrLf)
                    '.................................
                    .Append(vbCrLf)
                    '...............................
                    .Append("[STDB-1]" & vbCrLf)
                    .Append("NAAM=" & g_oSetupData.BOARD_LOCATION & sBoard & ".STD" & vbCrLf)
                    .Append("[STDB-1]" & vbCrLf)
                    '..............................
                    .Append(vbCrLf)
                    '...........................
               End With
               '********************************
               Try
                    'Pass the file path and name to the StreamWriter constructor.
                    'Indicate that Append is True, so file will not be overwritten.
                    '........... MODIFY CODE .............
                    fw = New StreamWriter(g_oSetupData.PART_LOCATION & Trim(sPartNumber) & ".R41") '"\\netserv22\public\NesterImport.txt")
                    'fw = New StreamWriter(PART_LOCATION_TEST & Trim(sPartNumber) & ".R41")
                    fw.WriteLine(sbR41.ToString)
                    fw.Close()
                    '........... MODIFY CODE .............
                    fw = New StreamWriter(g_oSetupData.PART_LOCATION & "Dummy.stk") '"\\netserv22\public\NesterImport.txt")
                    'fw = New StreamWriter(PART_LOCATION_TEST & "Dummy.stk")
                    fw.WriteLine("Dummy")
                    fw.Close()
                    fw = Nothing
                    Return sbR41.ToString
               Catch ex As Exception
                    If g_oSetupData.DEBUG_ON_OFF Then
                         gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "FAILED", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
                    Else
                         g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "FAIL", CLASS_NAME, FUNCTION_NAME)
                    End If
                    Return ex.Message & "fail"
               Finally
                    'Close the file.
                    fw = Nothing
               End Try


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function SetValue(ByVal sSection As String, _
                              ByVal oKey As Keys, _
                              ByVal sValue As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SetValue"
          '--------------------------------------
          '---------------------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '......................................
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    _dv.Item(0).Item("Value") = sValue
                    'Console.WriteLine("nderung am Key '{0}'", Key)
               Else
                    _dr = _ds.Tables(0).NewRow
                    _dr("Section") = sSection
                    _dr("Key") = keyValue
                    _dr("Value") = sValue
                    _ds.Tables(0).Rows.Add(_dr)
                    'Console.WriteLine("Neuer Eintrag: Key ='{0}' & Value = {1}", Key, Value)
               End If
               Return True
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function SaveR41() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SaveR41"
          '--------------------------------------
          Dim bolAnswer As Boolean = Nothing
          Try
               '..................................
               ' '' ''..... check file date ...........
               '' ''bolAnswer = CheckCurrentR41FileDate()
               '' ''If bolAnswer = True Then
               '' ''     '... the file date is the same as today...
               '' ''End If
               '.................................
               If Not IsNothing(_ds.GetChanges) Then
                    'SetValue("_LastSaveOfIniFile", Date.Now.ToLongDateString)
                    'Dim tmpString As String
                    Try
                         _dv.RowFilter = ""
                         '_dv.Sort = "KEY ASC"
                         Dim StringR41 As New StringBuilder
                         'StringR41.Append(_strPrefix & Environment.NewLine)
                         'StringIni.Append(_strIniArgumentsBegins & Environment.NewLine)
                         Dim i As Integer
                         For i = 0 To _dv.Count - 1
                              If _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" Then
                                   StringR41.Append(_dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringR41.Append(_dv.Item(i).Item("Section") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") <> "" And _dv.Item(i).Item("Key") <> "" And _dv.Item(i).Item("Value") <> "" Then
                                   StringR41.Append(_dv.Item(i).Item("Key") & "=" & _dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringR41.Append(Environment.NewLine)
                              End If
                         Next
                         If File.Exists(_strR41FileName) Then CreateBackupR41File(_strR41FileName)
                         'If File.Exists(_strR41FileName) Then File.Delete(_strR41FileName)
                         Dim ssw As New StreamWriter(_strR41FileName)
                         ssw.WriteLine(StringR41.ToString)
                         ssw.Close()
                         _ds.AcceptChanges()
                         Return True
                    Catch ex As Exception
                         '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
                         If g_oSetupData.DEBUG_ON_OFF Then
                              gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
                         Else
                              g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
                         End If
                         Return False
                    End Try
               Else
                    Return True
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
               bolAnswer = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     '===============================================================
     Private Function CreateBackupR41File(ByVal sFileName As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CreateBackupR41File"
          '--------------------------------------
          '... create backup of original file and save ....
          '... then delete original file .....
          Dim tmpString() As String
          Dim tmpString2() As String
          Dim intNumOfItems As Integer
          Dim strBackupFileExt As String = ".bkp"
          Dim strBackupFileName As String = Nothing
          Dim dBackupDate As Date = Nothing
          Dim strBackupDate As String = Nothing
          Dim strTemp As String
          Try
               '........................................
               dBackupDate = FormatDateTime(Now, DateFormat.GeneralDate)
               strBackupDate = Format(dBackupDate, "MM_dd_yy")
               '....................................
               tmpString = sFileName.Split("\")
               intNumOfItems = tmpString.Length
               strBackupFileName = tmpString.GetValue(intNumOfItems - 1)
               tmpString2 = strBackupFileName.Split(".")
               strBackupFileName = tmpString2.GetValue(0) & "-" & strBackupDate & strBackupFileExt
               strTemp = tmpString.GetValue(0) & "\" & tmpString.GetValue(1) & "\" & tmpString.GetValue(2) & "\" & tmpString.GetValue(3) & "\" & strBackupFileName
               '...... check to see if file exist .......
               If File.Exists(strTemp) Then
                    File.Delete(strTemp)
                    File.Copy(sFileName, strTemp)
                    File.Delete(sFileName)
               Else
                    File.Copy(sFileName, strTemp)
                    File.Delete(sFileName)
               End If

               strTemp = ""
               Return ""
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function DetermineSectionText(ByVal oSection As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "XXXX"
          '--------------------------------------
          Dim strSection As String
          Try
               strSection = ""
               Select Case oSection
                    Case Sections._ALGRES
                         strSection = "ALGRES"
                    Case Sections._ERROR
                         strSection = "ERROR" 'requires a number
                    Case Sections._ISTD
                         strSection = "ISTD" 'requires a number - number of boards
                    Case Sections._ISTK
                         strSection = "ISTK" 'requires a number
                    Case Sections._LAYOUTS
                         strSection = "LAYOUTS" 'requires a number - number of boards
                    Case Sections._LAYSTK
                         strSection = "LAYSTK" 'requires a number - number of boards
                         '....................... associated with LAYOUTS-#
                    Case Sections._LAYSTS
                         strSection = "LAYSTS"
                    Case Sections._LOCSTS
                         strSection = "LOCSTS"
                    Case Sections._MAT
                         strSection = "MAT" 'requires a number
                    Case Sections._MATRES
                         strSection = "MATRES" 'requires a number
                    Case Sections._MATSTKBRES
                         strSection = "MATSTKBRES" 'requires a number
                    Case Sections._MCHB
                         strSection = "MCHB" 'requires a number
                    Case Sections._OPTPAR
                         strSection = "OPTPAR"
                    Case Sections._STKB
                         strSection = "STKB" 'requires a number
                    Case Sections._STDB
                         strSection = "STDB" 'requires a number - number of boards
                    Case Sections._STKBRES
                         strSection = "STKBRES" 'requires a number
                    Case Sections._STKPROD
                         strSection = "STKPROD" 'requires a number
                    Case Sections._STKSTS
                         strSection = "STKSTS"
                    Case Sections._STROKEN
                         strSection = "STROKEN" 'requires a number - number of boards
                         '....................... associated with LAYOUTS-#
                    Case Sections._SUBSTS
                         strSection = "SUBSTS"
               End Select
               '..............................
               Return strSection
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return ""
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     Private Function DetermineKeyText(ByVal oKey As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "XXXX"
          '--------------------------------------
          Dim strKey As String = Nothing
          Try
               Select Case oKey
                    Case Keys._BEM
                         strKey = "BEM"
                    Case Keys._BRUTOPP
                         strKey = "BRUTOPP"
                    Case Keys._MACH
                         strKey = "NAAM"
                    Case Keys._NETTOPP
                         strKey = "NETTOPP"
                    Case Keys._REF
                         strKey = "REF"
                    Case Keys._STDNR
                         strKey = "STDNR"
                    Case Keys._MAT
                         strKey = ""
               End Select
               Return strKey
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
               strKey = Nothing
          End Try
     End Function
#End Region

End Class

Public Class STDFiles
     Private CLASS_NAME As String = MyBase.GetType().Name

#Region "Enums"
     Public Enum Sections
          _ISTDALG = 10
          _ISTDALG_FORM = 20
          _ISTD = 30
          _ISTD_FORM = 40
     End Enum
     Public Enum Keys
          _MATERIAAL = 10 'MATERIAL NAME
          _REFER = 20 'COST
          _BEM = 30 'BOARD NUMBER
     End Enum
#End Region 'Enums
#Region "Public/Private variables"
     Private _strSTDFileName As String
     Private _strISTDALGArguments As String = "[ISTDALG]"
     Private _strISTDALGFORMArguments As String = "[ISTDALG$FORM]"
     '........................................
     Private _strPrefix As String
     Private _dt As DataTable
     Private _ds As DataSet
     Private _dv As DataView
     Private _dr As DataRow
     Private TmpStringInhaltKomplett As New StringBuilder
     Private StringSTDFile As String
     '.................................
     Private m_FileExtension As String = "*.STD"
     '................................
     Private m_NumberofSTDFilesChanged As Integer
     Private m_STDFileNamesChanged As Collection
     '................................
     Private bf_dt As DataTable
     Private bf_ds As DataSet
     Private bf_dv As DataView
     Private bf_dr As DataRow
#End Region 'Public/Private variables
#Region "Properties"
     Public Property STDFilename() As String
          Get
               Return _strSTDFileName
          End Get
          Set(ByVal Value As String)
               _strSTDFileName = Value
          End Set
     End Property
     '----------------------------------------
     Public Property Prefix() As String
          Get
               Return _strPrefix
          End Get
          Set(ByVal Value As String)
               _strPrefix = Value
          End Set
     End Property
     '----------------------------------------
     Public Property GetDataSet() As DataSet
          Get
               Return bf_ds
          End Get
          Set(ByVal value As DataSet)
               bf_ds = value
          End Set
     End Property
     '----------------------------------------
     Public Property NumberofSTDFilesChanged() As Integer
          Get
               Return m_NumberofSTDFilesChanged
          End Get
          Set(ByVal Value As Integer)
               If Value = 0 Then
                    m_NumberofSTDFilesChanged = 0
               Else
                    m_NumberofSTDFilesChanged += Value
               End If

          End Set
     End Property
     '----------------------------------------
     Public Property STDFileNamesChanged() As Collection
          Get
               Return m_STDFileNamesChanged
          End Get
          Set(ByVal Value As Collection)
               m_STDFileNamesChanged = Value
          End Set
     End Property
     '----------------------------------------
#End Region 'Properties
#Region "Class Methods"
     Public Sub New()
          '... setup data set, table and view for STD files.....
          _ds = New DataSet
          _dt = New DataTable
          _dv = New DataView
          '...............................
          _dt.Columns.Add("Section")
          _dt.Columns.Add("Key")
          _dt.Columns.Add("Value")
          '...............................
          _ds.Tables.Add(_dt)
          _dv.Table = _ds.Tables(0)
          '------------------------------
          '... setup data set, table and view for BoardsFound in Update ...
          bf_ds = New DataSet
          bf_dt = New DataTable
          bf_dv = New DataView
          '......................
          bf_dt.Columns.Add("Item")
          bf_dt.Columns.Add("BoardNum")
          '........................
          bf_ds.Tables.Add(bf_dt)
          bf_dv.Table = bf_ds.Tables(0)
          '..........................
     End Sub
#End Region
#Region "Functions and subroutines"
     Public Function OpenSTDFile() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "OpenSTDFile"
          '--------------------------------------
          Try
               Dim tmpStringLine As String
               Dim tmpStrLn2 As String
               Dim tmpStringArguments() As String
               Dim tmpBool As Boolean = False
               Dim tmpStr1 As String = "["
               Dim tmpStr2 As String = "="
               If Not File.Exists(STDFilename) Then
                    Return False
               End If
               Dim ssr As StreamReader = New StreamReader(STDFilename)
               _ds = New DataSet
               _dt = New DataTable
               _dv = New DataView
               _dt.Columns.Add("Section")
               _dt.Columns.Add("Key")
               _dt.Columns.Add("Value")

               _ds.Tables.Add(_dt)
               _dv.Table = _ds.Tables(0)
               tmpStrLn2 = ""
               Do
                    tmpStringLine = ssr.ReadLine()
                    If tmpStringLine Is Nothing Then GoTo Continue1
                    '.... determine if comment or section or key .....
                    If InStr(tmpStringLine, tmpStr1) Then 'section...
                         Try
                              tmpStrLn2 = ""
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStringLine
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                              tmpStrLn2 = tmpStringLine
                         Catch ex As Exception

                         End Try
                    ElseIf InStr(tmpStringLine, tmpStr2) Then 'key...
                         Try
                              tmpStringArguments = tmpStringLine.Split("=")
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStrLn2
                              _dr("Key") = tmpStringArguments(0)
                              _dr("Value") = tmpStringArguments(1)
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine <> "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = tmpStringLine
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine = "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    End If
                    '......................................
                    TmpStringInhaltKomplett.Append(tmpStringLine & Environment.NewLine)
Continue1:
               Loop Until ssr.EndOfStream 'tmpStringLine Is Nothing
               ssr.Close()
               StringSTDFile = TmpStringInhaltKomplett.ToString
               Return True
               _ds.AcceptChanges()
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetSectionValue(ByVal oKey As Keys, _
                         ByVal kValue As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetSectionValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '.... get key value for filter ...........
               keyValue = DetermineKeyText(oKey)
               strFilter = "Key = '" & keyValue & "' and Value = '" & kValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Section")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetValue(ByVal sSection As String, _
                               ByVal oKey As Keys) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Value")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     Public Function SetValue(ByVal sSection As String, _
                              ByVal oKey As Keys, _
                              ByVal sValue As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SetValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '......................................
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    _dv.Item(0).Item("Value") = sValue
                    '.....................................
               Else
                    _dr = _ds.Tables(0).NewRow
                    _dr("Section") = sSection
                    _dr("Key") = keyValue
                    _dr("Value") = sValue
                    _ds.Tables(0).Rows.Add(_dr)
                    '...................................
               End If
               Return True
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetBoardCount(ByVal oSection As Sections) As Integer
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetBoardCount"
          '--------------------------------------
          Dim bolAnswer As Boolean = Nothing
          Try

               Dim sectValue As String
               Dim strFilter As String
               Dim intcntr As Integer
               Dim intSectionCnt As Integer

               sectValue = DetermineSectionText(oSection)
               strFilter = "[" & sectValue
               For intcntr = 0 To _dv.Count - 1
                    If _dv.Item(intcntr).Item("Section") <> "" And _dv.Item(intcntr).Item("Key") = "" Then
                         If InStr(_dv.Item(intcntr).Item("Section"), strFilter) = 1 Then
                              intSectionCnt += 1
                         End If
                    End If
               Next
               Return intSectionCnt / 2

          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               bolAnswer = -1
          Finally
               FUNCTION_NAME = Nothing
               bolAnswer = Nothing
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function SaveSTDFile() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SaveSTDFile"
          '--------------------------------------
          Try
               '..................................
               If Not IsNothing(_ds.GetChanges) Then
                    'SetValue("_LastSaveOfIniFile", Date.Now.ToLongDateString)
                    'Dim tmpString As String
                    Try
                         _dv.RowFilter = ""
                         '_dv.Sort = "KEY ASC"
                         Dim StringSTD As New StringBuilder
                         'StringR41.Append(_strPrefix & Environment.NewLine)
                         'StringIni.Append(_strIniArgumentsBegins & Environment.NewLine)
                         Dim i As Integer
                         For i = 0 To _dv.Count - 1
                              If _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Section") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") <> "" And _dv.Item(i).Item("Key") <> "" And _dv.Item(i).Item("Value") <> "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Key") & "=" & _dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringSTD.Append(Environment.NewLine)
                              End If
                         Next
                         If File.Exists(_strSTDFileName) Then CreateBackupSTDFile(_strSTDFileName)
                         'If File.Exists(_strR41FileName) Then File.Delete(_strR41FileName)
                         Dim ssw As New StreamWriter(_strSTDFileName)
                         ssw.WriteLine(StringSTD.ToString)
                         ssw.Close()
                         _ds.AcceptChanges()
                         Return True
                    Catch ex As Exception
                         '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
                         If g_oSetupData.DEBUG_ON_OFF Then
                              gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
                         Else
                              g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
                         End If
                         Return False
                    End Try
               Else
                    Return True
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetBoardFilesList(ByVal sDirectory As String, _
                                   ByVal bProductionYN As Boolean) As Collection
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetBoardFilesList"
          '--------------------------------------
          Dim clFileCollection As Collection = Nothing
          Dim sFileName As String = Nothing
          Try
               '...........................
               clFileCollection = New Collection
               sFileName = Dir(sDirectory & Me.m_FileExtension, FileAttribute.Directory)
               '.......................................
               Do While sFileName <> ""
                    clFileCollection.Add(sFileName)
                    sFileName = Dir()
               Loop
               '............................
               Return clFileCollection
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return Nothing
          Finally
               FUNCTION_NAME = Nothing
               clFileCollection = Nothing
               sFileName = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CheckCurrentSTDFileDate() As Boolean

     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function UpdateSTDBoardFiles(ByVal clBrdCollection As Collection, _
                                         ByVal sDirectory As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "UpdateSTDBoardFiles"
          '--------------------------------------
          Try
               '... not currently used....


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function UpdateSTKBoardFiles(ByVal clBrdCollection As Collection, _
                                      ByVal sDirectory As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "UpdateSTKBoardFiles"
          '--------------------------------------
          Try
               '... not currently used....


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CreateSTDFile(ByVal sDirectory As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CreateSTDFile"
          '--------------------------------------
          Try
               '... not currently used....


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function CreateSTKFile(ByVal sPartNumber As String, ByVal sBoard As String, _
                                   ByVal sLength As String, ByVal sWidth As String, _
                                   ByVal sRotation As String, ByVal sBulkCut As String, _
                                   ByVal sQtyNeeded As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CreateSTKFile"
          '--------------------------------------
          Try
               '... not currently used....
               Dim fw As StreamWriter
               Dim sbSTK As New StringBuilder
               '...........................................
               sbSTK.Append("[ISTK-1]" & vbCrLf)
               sbSTK.Append("BEM=" & sBulkCut & vbCrLf)
               sbSTK.Append("MAT=" & sBoard & vbCrLf)
               If sRotation = "0" Then
                    sbSTK.Append("R=1" & vbCrLf)
               End If
               sbSTK.Append("L=" & sLength & vbCrLf)
               sbSTK.Append("B=" & sWidth & vbCrLf)
               '................................
               If IsNumeric(CInt(sQtyNeeded)) Then
                    sbSTK.Append("A=" & sQtyNeeded & vbCrLf) 'TODO this needs to be configurable
               Else
                    sbSTK.Append("A=" & 1000 & vbCrLf) 'TODO this needs to be configurable
               End If
               '............................................
               sbSTK.Append("[ISTK-1]" & vbCrLf)
               sbSTK.Append(vbCrLf)
               '..............................
               sbSTK.Append("[ISTK$FORM-1]" & vbCrLf)
               sbSTK.Append("[ISTK$FORM-1]" & vbCrLf)
               sbSTK.Append(vbCrLf)
               '............................
               sbSTK.Append("[ISTKALG]" & vbCrLf)
               sbSTK.Append("ALGREF=" & Trim(sPartNumber) & vbCrLf)
               sbSTK.Append("DATUM=" & Now.Day & Now.Month & Right(Now.Year, 2) & vbCrLf) '270105
               sbSTK.Append("[ISTKALG]" & vbCrLf)
               sbSTK.Append(vbCrLf)
               '................................................
               sbSTK.Append("[ISTKALG$FORM]" & vbCrLf)
               sbSTK.Append("[ISTKALG$FORM]")
               '........................................
               Try
                    'Pass the file path and name to the StreamWriter constructor.
                    'Indicate that Append is True, so file will not be overwritten.
                    '........... MODIFY CODE .............
                    fw = New StreamWriter(g_oSetupData.PART_LOCATION & Trim(sPartNumber) & ".stk") '"\\netserv22\public\NesterImport.txt")
                    'fw = New StreamWriter(PART_LOCATION_TEST & Trim(sPartNumber) & ".stk")
                    fw.WriteLine(sbSTK.ToString)
                    fw.Close()
                    Return sbSTK.ToString
               Catch ex As Exception
                    If g_oSetupData.DEBUG_ON_OFF Then
                         gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
                    Else
                         g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
                    End If
                    Return ex.Message & "fail"
               Finally
                    'Close the file.
                    fw = Nothing
               End Try


          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     '===============================================================
     Private Function CreateBackupSTDFile(ByVal sFileName As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CreateBackupSTDFile"
          '--------------------------------------
          '... create backup of original file and save ....
          '... then delete original file .....
          Dim tmpString() As String
          Dim tmpString2() As String
          Dim intNumOfItems As Integer
          Dim strBackupFileExt As String = ".bkp"
          Dim strBackupFileName As String = Nothing
          Dim dBackupDate As Date = Nothing
          Dim strBackupDate As String = Nothing
          Dim strTemp As String
          Try
               '........................................
               dBackupDate = FormatDateTime(Now, DateFormat.GeneralDate)
               strBackupDate = Format(dBackupDate, "MM_dd_yy")
               '....................................
               tmpString = sFileName.Split("\")
               intNumOfItems = tmpString.Length
               strBackupFileName = tmpString.GetValue(intNumOfItems - 1)
               tmpString2 = strBackupFileName.Split(".")
               strBackupFileName = tmpString2.GetValue(0) & strBackupDate & strBackupFileExt
               strTemp = tmpString.GetValue(0) & "\" & tmpString.GetValue(1) & "\" & tmpString.GetValue(2) & "\" & tmpString.GetValue(3) & "\" & strBackupFileName
               '...... check to see if file exist .......
               If File.Exists(strTemp) Then
                    File.Delete(strTemp)
                    File.Copy(sFileName, strTemp)
                    File.Delete(sFileName)
               Else
                    File.Copy(sFileName, strTemp)
                    File.Delete(sFileName)
               End If
               strTemp = ""
               Return "Done"
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Nothing"
          Finally
               FUNCTION_NAME = Nothing
               tmpString = Nothing
               tmpString2 = Nothing
               intNumOfItems = Nothing
               strBackupFileExt = Nothing
               strBackupFileName = Nothing
               strBackupDate = Nothing
               strTemp = Nothing
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function DetermineSectionText(ByVal oSection As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "DetermineSectionText"
          '--------------------------------------
          Dim strSection As String = Nothing
          Try
               '................................
               Select Case oSection
                    Case Sections._ISTD
                         strSection = "ISTD"
                    Case Sections._ISTD_FORM
                         strSection = "ISTD$FORM"
                    Case Sections._ISTDALG
                         strSection = "ISTDALG"
                    Case Sections._ISTDALG_FORM
                         strSection = "ISTDALG$FORM"
               End Select
               '..............................
               Return strSection
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return ""
          Finally
               FUNCTION_NAME = Nothing
               strSection = Nothing
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function DetermineKeyText(ByVal oKey As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "DetermineKeyText"
          '--------------------------------------
          Dim strKey As String = Nothing
          Try
               '.................................
               Select Case oKey
                    Case Keys._BEM
                         strKey = "BEM"
                    Case Keys._MATERIAAL
                         strKey = "MATERIAAL"
                    Case Keys._REFER
                         strKey = "REFER"
               End Select
               Return strKey
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return ""
          Finally
               FUNCTION_NAME = Nothing
               strKey = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Sub StoreBoardsFoundToUpdate(ByVal oBoardNum As String)
          '-----------------------------------
          Dim SUB_NAME As String = "StoreBoardsFoundToUpdate"
          '-----------------------------------
          Dim intBrdCntr As Integer = Nothing
          Try
               Dim strFilter As String
               '......................................
               strFilter = "BoardNum = '" & oBoardNum & "'"
               '...............................
               bf_dv.RowFilter = strFilter
               '...............................
               If bf_dv.Count > 0 Then
                    '... do nothing ....
               Else
                    bf_dr = bf_ds.Tables(0).NewRow
                    If bf_dr.Table.Rows.Count = 0 Then
                         intBrdCntr = 1
                    Else
                         intBrdCntr = bf_dr.Table.Rows.Count + 1
                    End If
                    '...............................
                    bf_dr("Item") = intBrdCntr
                    bf_dr("BoardNum") = oBoardNum
                    bf_ds.Tables(0).Rows.Add(bf_dr)
               End If
               '.....................................
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, SUB_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oSub)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, SUB_NAME)
               End If
          Finally
               SUB_NAME = Nothing
          End Try

     End Sub
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#End Region

End Class


Public Class MachineFiles
     Private CLASS_NAME As String = MyBase.GetType().Name

#Region "Enums"
     Public Enum Sections
          _PP = 10
          _SNIJKNL = 20 '...MULTIPLY ITEMS
          _SNIJKNL_FORM = 30 'SNIJKNL$FORM - ...MULTIPLY ITEMS
          _AANTBEPL = 40
          _AANTBEPL_FORM = 50 'AANTBEPL$FORM
          _MAATBEPL = 60
          _MAATBEPL_FORM = 70 'MAATBEPL$FORM
          _HOEKBEPL = 80
          _KOPSNL = 90
          _KOPSNL_FORM = 100 'KOPSNL$FORM
          _MACHTB = 110
          _MACHTB_FORM = 120 'MACHTB$FORM
          _HOEKDR = 130
          _SNIJKND = 140 '...MULTIPLY ITEMS
          _SNIJKND_FORM = 150 'SNIJKND$FORM - ...MULTIPLY ITEMS
          _AANTBEPD = 160
          _AANTBEPD_FORM = 170 'AANTBEPD$FORM
          _MAATBEPD = 180
          _MAATBEPD_FORM = 190 'MAATBEPD$FORM
          _HOEKBEPD = 200
          _KOSTEN = 210
          _KOPSND = 220
          _KOPSND_FORM = 230 'KOPSND$FORM
          _ASTKBEP = 240
          _ASTKBEP_FORM = 250 'ASTKBEP$FORM
     End Enum
     Public Enum Keys
          _OMSCHR = 10 'Default machine
     End Enum
#End Region 'Enums
#Region "Constants"

#End Region  'Constants
#Region "Public/Private variables"
     Private _strMCHFileName As String
     '......................................................
     Private _strPrefix As String
     Private _dt As DataTable
     Private _ds As DataSet
     Private _dv As DataView
     Private _dr As DataRow
     Private TmpStringInhaltKomplett As New StringBuilder
     Private StringMCHFile As String
     '.................................
     Private m_FileExtension As String = "*.MCH"
#End Region 'Public/Private variables
#Region "Properties"
     Public Property MCHFilename() As String
          Get
               Return _strMCHFileName
          End Get
          Set(ByVal Value As String)
               _strMCHFileName = Value
          End Set
     End Property
     '----------------------------------------
     Public Property Prefix() As String
          Get
               Return _strPrefix
          End Get
          Set(ByVal Value As String)
               _strPrefix = Value
          End Set
     End Property
     '-----------------------------------------

#End Region 'Properties
#Region "Class Methods"
     Public Sub New()
          _ds = New DataSet
          _dt = New DataTable
          _dv = New DataView
          '...............................
          _dt.Columns.Add("Section")
          _dt.Columns.Add("Key")
          _dt.Columns.Add("Value")
          '...............................
          _ds.Tables.Add(_dt)
          _dv.Table = _ds.Tables(0)
     End Sub
#End Region
#Region "Functions and subroutines"
     Public Function OpenMCHFile() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "OpenMCHFile"
          '--------------------------------------
          Try
               Dim tmpStringLine As String
               Dim tmpStrLn2 As String
               Dim tmpStringArguments() As String
               Dim tmpBool As Boolean = False
               Dim tmpStr1 As String = "["
               Dim tmpStr2 As String = "="
               If Not File.Exists(MCHFilename) Then
                    Return False
               End If
               Dim ssr As StreamReader = New StreamReader(MCHFilename)
               _ds = New DataSet
               _dt = New DataTable
               _dv = New DataView
               _dt.Columns.Add("Section")
               _dt.Columns.Add("Key")
               _dt.Columns.Add("Value")

               _ds.Tables.Add(_dt)
               _dv.Table = _ds.Tables(0)
               tmpStrLn2 = ""
               Do
                    tmpStringLine = ssr.ReadLine()
                    If tmpStringLine Is Nothing Then GoTo Continue1
                    '.... determine if comment or section or key .....
                    If InStr(tmpStringLine, tmpStr1) Then 'section...
                         Try
                              tmpStrLn2 = ""
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStringLine
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                              tmpStrLn2 = tmpStringLine
                         Catch ex As Exception

                         End Try
                    ElseIf InStr(tmpStringLine, tmpStr2) Then 'key...
                         Try
                              tmpStringArguments = tmpStringLine.Split("=")
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = tmpStrLn2
                              _dr("Key") = tmpStringArguments(0)
                              _dr("Value") = tmpStringArguments(1)
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine <> "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = tmpStringLine
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    ElseIf tmpStringLine = "" Then
                         Try
                              _dr = _ds.Tables(0).NewRow
                              _dr("Section") = ""
                              _dr("Key") = ""
                              _dr("Value") = ""
                              _ds.Tables(0).Rows.Add(_dr)
                         Catch ex As Exception

                         End Try
                    End If
                    '......................................
                    TmpStringInhaltKomplett.Append(tmpStringLine & Environment.NewLine)
Continue1:
               Loop Until ssr.EndOfStream 'tmpStringLine Is Nothing
               ssr.Close()
               MCHFilename = TmpStringInhaltKomplett.ToString
               Return True
               _ds.AcceptChanges()
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetSectionValue(ByVal oKey As Keys, _
                    ByVal kValue As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetSectionValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '.... get key value for filter ...........
               keyValue = DetermineKeyText(oKey)
               strFilter = "Key = '" & keyValue & "' and Value = '" & kValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Section")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetValue(ByVal sSection As String, _
                          ByVal oKey As Keys) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    Return _dv.Item(0).Item("Value")
               Else
                    Return "NOTHING"
               End If
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Error"
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function SetValue(ByVal sSection As String, _
                           ByVal oKey As Keys, _
                           ByVal sValue As String) As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SetValue"
          '--------------------------------------
          Try
               Dim keyValue As String
               Dim strFilter As String
               '......................................
               keyValue = DetermineKeyText(oKey)
               strFilter = "Section = '" & sSection & "' and Key = '" & keyValue & "'"
               _dv.RowFilter = strFilter
               If _dv.Count > 0 Then
                    _dv.Item(0).Item("Value") = sValue
                    '.....................................
               Else
                    _dr = _ds.Tables(0).NewRow
                    _dr("Section") = sSection
                    _dr("Key") = keyValue
                    _dr("Value") = sValue
                    _ds.Tables(0).Rows.Add(_dr)
                    '...................................
               End If
               Return True
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function SaveSTDFile() As Boolean
          '--------------------------------------
          Dim FUNCTION_NAME As String = "SaveSTDFile"
          '--------------------------------------
          Try
               '..................................
               If Not IsNothing(_ds.GetChanges) Then
                    'SetValue("_LastSaveOfIniFile", Date.Now.ToLongDateString)
                    'Dim tmpString As String
                    Try
                         _dv.RowFilter = ""
                         '_dv.Sort = "KEY ASC"
                         Dim StringSTD As New StringBuilder
                         'StringR41.Append(_strPrefix & Environment.NewLine)
                         'StringIni.Append(_strIniArgumentsBegins & Environment.NewLine)
                         Dim i As Integer
                         For i = 0 To _dv.Count - 1
                              If _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Section") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") <> "" And _dv.Item(i).Item("Key") <> "" And _dv.Item(i).Item("Value") <> "" Then
                                   StringSTD.Append(_dv.Item(i).Item("Key") & "=" & _dv.Item(i).Item("Value") & Environment.NewLine)
                              ElseIf _dv.Item(i).Item("Section") = "" And _dv.Item(i).Item("Key") = "" And _dv.Item(i).Item("Value") = "" Then
                                   StringSTD.Append(Environment.NewLine)
                              End If
                         Next
                         If File.Exists(_strMCHFileName) Then CreateBackupMCHFile(_strMCHFileName)
                         'If File.Exists(_strR41FileName) Then File.Delete(_strR41FileName)
                         Dim ssw As New StreamWriter(_strMCHFileName)
                         ssw.WriteLine(StringSTD.ToString)
                         ssw.Close()
                         _ds.AcceptChanges()
                         Return True
                    Catch ex As Exception
                         '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
                         If g_oSetupData.DEBUG_ON_OFF Then
                              gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
                         Else
                              g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
                         End If
                         Return False
                    End Try
               Else
                    Return True
               End If
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return False
          Finally
               FUNCTION_NAME = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function GetMachineFilesList(ByVal sDirectory As String, _
                              ByVal bProductionYN As Boolean) As Collection
          '--------------------------------------
          Dim FUNCTION_NAME As String = "GetMachineFilesList"
          '--------------------------------------
          Dim clFileCollection As Collection = Nothing
          Dim sFileName As String = Nothing
          Try
               '...........................
               clFileCollection = New Collection
               sFileName = Dir(sDirectory & Me.m_FileExtension, FileAttribute.Directory)
               '.......................................
               Do While sFileName <> ""
                    clFileCollection.Add(sFileName)
                    sFileName = Dir()
               Loop
               '............................
               Return clFileCollection
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return Nothing
          Finally
               FUNCTION_NAME = Nothing
               clFileCollection = Nothing
               sFileName = Nothing
          End Try
     End Function
     '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Public Function RemoveMCH_Files() As Boolean
          '----------------------------------------------
          Dim SUB_NAME As String = "RemoveMCH_Files"
          '----------------------------------------------
          'Dim intCntr As Integer
          Dim bolAnswer As Boolean
          'Dim intNumOfMachines As Integer
          'Dim strMachineName As String
          Try
               'TODO .... FINISH CODE .... 02-19-08
               'My.Computer.FileSystem.CurrentDirectory = PART_LOCATION
               For Each foundFile As String In My.Computer.FileSystem.GetFiles( _
                   My.Computer.FileSystem.CurrentDirectory, _
                   FileIO.SearchOption.SearchTopLevelOnly, "*.MCH")

                    My.Computer.FileSystem.DeleteFile(foundFile, _
                        FileIO.UIOption.OnlyErrorDialogs, _
                        FileIO.RecycleOption.DeletePermanently)
               Next


               'intNumOfMachines = g_oSetupData.MachineCollection.Count
               'For intCntr = 1 To intNumOfMachines
               '     strMachineName = g_oSetupData.mc_MachineCollection.Item(intCntr)
               '     My.Computer.FileSystem.DeleteFile(PART_LOCATION & strMachineName)
               'Next
          Catch ex As System.IO.FileNotFoundException
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, SUB_NAME, "FileNotFoundExceptio", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oSub)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "FileNotFoundExceptio", CLASS_NAME, SUB_NAME)
               End If
               bolAnswer = False
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, SUB_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, SUB_NAME)
               End If
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function DetermineKeyText(ByVal oKey As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "DetermineKeyText"
          '--------------------------------------
          Dim strKey As String = Nothing
          Try
               '.................................
               Select Case oKey
                    Case Keys._OMSCHR 'default machine
                         strKey = "OMSCHR"
               End Select
               Return strKey
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return ""
          Finally
               FUNCTION_NAME = Nothing
               strKey = Nothing
          End Try
     End Function
     '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     Private Function DetermineSectionText(ByVal oSection As Integer) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "DetermineSectionText"
          '--------------------------------------
          Dim strSection As String = Nothing
          Try
               'TODO ... finish code 02-19-08
               '................................
               Select Case oSection
                    Case Sections._AANTBEPD
                         strSection = "AANTBEPD"

               End Select
               '..............................
               Return strSection
          Catch ex As Exception
               '<<<<<<<<<<<<<<<<< error msg with debug option msg >>>>>>>>>>>>>>>>
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return ""
          Finally
               FUNCTION_NAME = Nothing
               strSection = Nothing
          End Try
     End Function
     '===============================================================================
     Private Function CreateBackupMCHFile(ByVal sFileName As String) As String
          '--------------------------------------
          Dim FUNCTION_NAME As String = "CreateBackupSTDFile"
          '--------------------------------------
          '... create backup of original file and save ....
          '... then delete original file .....
          Dim tmpString() As String
          Dim tmpString2() As String
          Dim intNumOfItems As Integer
          Dim strBackupFileExt As String = ".bkp"
          Dim strBackupFileName As String = Nothing
          Dim strBackupDate As String = Nothing
          Dim strTemp As String
          Try
               '........................................
               strBackupDate = Format(Now, "mm-dd-yy")
               tmpString = sFileName.Split("\")
               intNumOfItems = tmpString.Length
               strBackupFileName = tmpString.GetValue(intNumOfItems - 1)
               tmpString2 = strBackupFileName.Split(".")
               strBackupFileName = tmpString2.GetValue(0) & strBackupDate & strBackupFileExt
               strTemp = tmpString.GetValue(0) & "\" & tmpString.GetValue(1) & "\" & tmpString.GetValue(2) & "\" & tmpString.GetValue(3) & "\" & strBackupFileName
               File.Copy(sFileName, strTemp)
               File.Delete(sFileName)
               strTemp = ""
               Return "Done"
          Catch ex As Exception
               If g_oSetupData.DEBUG_ON_OFF Then
                    gbol_Answerval = g_MsgFile.StoreMessageToFile(CLASS_NAME, FUNCTION_NAME, "Error Message Encountered", ex.Message, clsMessageFile.MessageType.ErrorMsg, clsMessageFile.Class_FormType.oFunction)
               Else
                    g_oError.WriteToLog(ex.Message, clsError.EV_Error_Type.oError, "NOT KNOWN", CLASS_NAME, FUNCTION_NAME)
               End If
               Return "Nothing"
          Finally
               FUNCTION_NAME = Nothing
               tmpString = Nothing
               tmpString2 = Nothing
               intNumOfItems = Nothing
               strBackupFileExt = Nothing
               strBackupFileName = Nothing
               strBackupDate = Nothing
               strTemp = Nothing
          End Try
     End Function
#End Region 'Functions and subroutines

End Class
